
define ([
	'jquery',
	'bridge',
	'VConsole' // 打印log
], function($, Bridge, VConsole) {

	var uniqueId = 1

	var isCelluarTelephone;
	var screenWidth;
	var fontSize;
    var imageHostUrl;   //图片
    var newsHostUrl;	//资讯
    var forumHostUrl;	//论坛
    var routeHostUrl;	//路线
    var productHostUrl; //产品
    var shopHostUrl;	//车店

	var headerContainer = document.querySelector('#header-container');
	var container = document.querySelector('#view-newsDetail .content .bd');
        
	// 入口
	var initialize = function() {
//        var vConsole = new VConsole(); //TODO: 控制台打印开关 上线关闭

		initBridge();
	};

	// 调用OC返回的数据
	var initBridge = function() {

		// 接收来自android的回调
        window.newsDetailInit = function(data)  {

				fontSize = data.fontSize;           // 原生中设置的字体大小
				screenWidth = data.screenWidth;     // 设备宽度
				screenHeight = data.screenHeight;   // 设备高度
				// 获取域名
                imageHostUrl = data.imageSdnHost;   //图片
                newsHostUrl = data.newsHostUrl;	    //资讯
    			forumHostUrl = data.forumHostUrl;	//论坛
    			routeHostUrl = data.routeHostUrl;	//路线
    			productHostUrl = data.productHostUrl; //产品
    			shopHostUrl = data.shopHostUrl;	    //车店
                console.log('detailsObj:' + data)

				// details object
                var detailsObj = data.html;
                console.log('detailsObj:' + detailsObj)
                                   
				// 渲染html
				render(detailsObj);

                // 头部
                setHeaderContainer(detailsObj);
                                   
				// 设置字体大小
				setContainerFontSize(fontSize);
                                   
                //点击事件处理
                onClickLiksDelegate();

                //配置UI显示
				configureUI(detailsObj);

		}
	}

	var configureUI = function(detailsObj) {
        
		// 请求拿到数据结果后才显示，（否则在请求过程中会显示空的栏目）
		if (detailsObj.guide_list && detailsObj.bigImgMode == 1 && detailsObj.guide_list.length > 0) {
			document.body.removeChild(document.getElementById("header-container"));
			$(recommendItemContainer, container).css('visibility', 'visible');
		}
        else {
//            document.body.removeChild(document.getElementById("recommend-item-container"));
            $(headerContainer, container).css('visibility', 'visible');
        }
	}

	// 渲染HTML
	var render = function(details) {
        console.log('render');
		var newstext = details.newstext.replace(/(\[!--empirenews.page--\])/g, '')
									   .replace(/(<img[^>]*?)src/ig, function(all,$1){
											return $1 +'src="img/image-loading.png" data-src';
										})
									   .replace(/<span[^>]*>/g, '')
									   .replace(/<em[^>]*>/g, '')
									   .replace(/<(?!img|table|iframe|a|strong|p|\/p|div|\/div|).*?>/g, '')
        
		var content = document.querySelector('#view-newsDetail .content');
		container.innerHTML.scrollTop = 0;
		container.style.fontSize = '16px';
		$(container).html(newstext);
		setContainerStyleAndOperation( content , container.clientWidth)
	}

	// onclick 事件委托
	var onClickLiksDelegate = function() {

		var delegateHandle = function(event) {
			event.preventDefault();

			var me = $(this);
			var src = me[0].href;

			// 点击超链接
			if (me[0].tagName == 'A' && me.attr('href') != undefined) {

				if (src == 'javascript:;') return;

				var liksResultJson = getLiksIdAndType(src);

				if (liksResultJson) {
//                    Bridge.connect(function(bridge){
//                        bridge.callHandler('delegateUIWebViewOnClikEvent', {'result': liksResultJson})
//                    });
                      window.ANDROID.delegateUIWebViewOnClikEvent(JSON.stringify({'result': liksResultJson}));
				}
            }
		}

        $('a').click(delegateHandle);
	}
        
	// 设置相关样式
	var setContainerStyleAndOperation = function(newstext, containerWidth) {
		// 遍历dom节点
		var allDom = newstext.getElementsByTagName('p');
		var collectTemp = [];
		var imagesIndex = 0;
		var imageCount = 0;

		for (var i = 0; i < allDom.length; i++) collectTemp[collectTemp.length] = allDom[i];

        // Imges Tage
        var lineImagesForEach = function(i) {
            var $this = $(this);
            var $imageParent = $this.parents('p');
            imagesIndex ++;
            // 获取图片地址
            var imgSrc = $this.attr('data-src');
            var isDailysImgIcon = $this.attr('data-width') == 99 ? true : false; // 判断是否是每一图的下载按钮图标
            var imageSize = isDailysImgIcon ? "" : setImageSize(imgSrc);
            var sdnRootUrl = imgSrc;
            if (imgSrc.indexOf('http') == -1) { 
            	sdnRootUrl = imageHostUrl + imgSrc + imageSize;
            }
            var imgWidth = $this.attr('width');
            var imgHeight = $this.attr('height');
			var customWidth = containerWidth;

			// 默认高度 3:2
			var w = customWidth ;
            var h = customWidth * 2 / 3;
        	if( imgWidth && imgHeight ){
				w = imgWidth ;
				h = imgHeight ;
				if( imgWidth > customWidth ){
					w = customWidth ;
					h = customWidth * imgHeight / imgWidth;
				}
			}

            var imagesLength = collectTemp.length;
        
            $this.attr('data-index', imagesIndex);
        
            var img = new Image();
            img.src = sdnRootUrl;
    
            // 外连图片
            if (imgSrc.indexOf('http://') != -1|| imgSrc.indexOf('https') != -1) {
                $this.attr('src', imgSrc);
            }
            else {
                $this.attr('src', 'img/image-loading.png');
                // 加载完成执行
                img.onload = function(){
                    $this.addClass('animated fadeIn');
                    $this.attr('src', this.src); // www.biketo.com
                }
            }

            // 图片宽度
			$this.width(w);
			$this.height(h);
            $this.css({'border-raduis':'10px'});
            // 类名为img-intro的图片 下面插入描述  \u25b2->黑三角
//            var imgIntroClass = $this.attr('class');
//            if (imgIntroClass && imgIntroClass.indexOf('img-intro') !== -1) {
//                console.log($this.attr('data-desc'));
//                if ($this.attr('data-desc')) {
//                    $this.parent().after('<p style="text-align: center" class="img-intro-des">\u25b2'+  $this.attr('data-desc') +'</p>');
//                }
//            }
        
            // 图片居中 文字缩进 下边距
            $imageParent.css({ 'text-align': 'center', 'margin-bottom': '0', 'text-indent': '0'});
    
            // 判断每日一图下载图标时隐藏, 判断图片高宽度 ( 如果img的上上级元素是P元素，并且包含2个a元素 或 其中一个是a元素 )
            var that = $this.parents('a');
            if (that.length !=0 ) {
                if (that.length == 2 || that[0].tagName == 'A' || that[1].tagName == 'A') {
                    $imageParent.remove();
                }
            }

        }
        
		var firstForEache = function(i) {

			var $this = $(this);
			var $imagesTag = $this.find('img');
			var $iframeTag = $this.find('iframe');
			var $embedTag = $this.find('embed');
			var $imageParent = $imagesTag.parents('p');
			$this.find('strong').css('font-size', fontSize +1);
        
            //图片
            if( $imagesTag.length > 0 ){
                $imagesTag.each(lineImagesForEach);
            }

			// Iframe Tag
			if ($iframeTag[0]) {

				$iframeTag.attr('src', $iframeTag.attr('data-src'));
				$iframeTag.attr('allowfullscreen','true');
				$iframeTag.parents('p').css({'text-align': 'center', 'text-indent': '0'});
                var iframeHeight = $iframeTag ? $iframeTag.attr('height') : '0';
                var scaleHeight = containerWidth * (2/3);
                iframeHeight = iframeHeight.replace('px','');
                if(iframeHeight > scaleHeight){
				    $iframeTag.css({'height': scaleHeight +'px'});
                }
			};

			// Embed tag 非HTML的视屏，直接删除
			if ($embedTag) $embedTag.remove();

			// 最后一个p元素
			if (i == collectTemp.length -1) {
				if (collectTemp[i].innerHTML.indexOf('责任编辑') <= 1) collectTemp[i].style.textAlign = "left";
			};
		}

		var lineImagesSecondEach = function(i) {
			var $this = $(this);
			var $imagesTag = $this.find('img');
        
			var imgSrc =  $this.attr('data-src');
			var imgWidth =  $this.attr('width');
			var imgHeight =  $this.attr('height');

			var customWidth = containerWidth;
			var scale = imgWidth/customWidth;
			var heightScale = Math.floor(imgHeight/scale);

			if( imgWidth && imgHeight ){
				return;
			}

			// 如果是外链则跳过
            if ( imgSrc.indexOf('http://') != -1|| imgSrc.indexOf('https') != -1) {
                $this.css({ 'width': '100%', 'height': 'auto' });
                return;
            }

			// 否则将通过服务器图片API获取高度
			var requestGetImageInfoCallback = function(response) {
				// 计算图片比例
				var height = response.height;
				var width = response.width;
				var customWidth = containerWidth;

				var w = customWidth ;
				var h = customWidth * 2 / 3;
				if( width && height ){
					w = width ;
					h = height ;
					if( width > customWidth ){
						w = customWidth ;
						h = customWidth * height / width;
					}
				}
			
				if (!$this) return;

				var imagesIndex = $this.attr('data-index');

				// 设置图片宽高
		        $this.width(w);
				$this.height(h);
			}

			// 获取占位符高度, 并返回最终的高度
			$.ajax({type : 'get',
				url : 'https://ofac4w3f7.qnssl.com' + imgSrc +'?imageInfo&time='+new Date().getTime(),
				data : '',
				async : true,
				success : requestGetImageInfoCallback
			});
		}

		var secondForEache = function(i) {
			var $this = $(this);
			var $imagesTag = $this.find('img');

			if($imagesTag.length>0){
				$imagesTag.each(lineImagesSecondEach);
			}
		}

		$(collectTemp).each(firstForEache);
		$(collectTemp).each(secondForEache);

		collectTemp = null;
	}

	// 设置图片大小，从OC中获取
	var setImageSize = function(imageSrc) {
		//是否开去省流量模式
		var imageW = '';

		if (isCelluarTelephone == 1) {
			imageW = '?x-oss-process=image/resize,w_' +screenWidth;
		}
        else {
			imageW = '?x-oss-process=image/resize,w_640';
		}
        
        if (imageSrc.indexOf('.gif') == -1) {
            imageW = imageW + '/format,webp';
        }

		return imageW;
	}

        
    // 头部
    var setHeaderContainer = function(data) {
        $(headerContainer).find('.title').html(data.title);
//        $(headerContainer).find('#header-container-author').html(data.writer);
//        $(headerContainer).find('#header-container-time').html(data.newstime);
//        $(headerContainer).find('#header-container-click').html(data.onclick);
    }
        
	// 字体大小
	var setContainerFontSize = function(fontSize) {
		$(container).css('font-size', fontSize +'px');
		var headerFontSize = new Number(fontSize);
		$(headerContainer).find('.title').css('font-size', (headerFontSize += 8) +'px');
	}

	// Log输出
	var log = function(message, data) {
		var logWrap = document.createElement('div');
		var log = document.getElementById('log')
		var el = document.createElement('div')
		el.className = 'logLine'
		el.innerHTML = uniqueId++ + '. ' + message + ':<br/>' + JSON.stringify(data)
		if (log.children.length) { log.insertBefore(el, log.children[0]) }
		else { log.appendChild(el) }
	}

	return { init : initialize };
})
