
define ([
	'jquery',
	'bridge',
	'detailContent',
	'lazyImages', // 图片懒加载，未实现！
	'fastclick',
	'artTemplate',
	'VConsole' // 打印log
], function($, Bridge, DetailContent, lazyImages, Fastclick, artTemplate, VConsole) {

	var uniqueId = 1

	var isCelluarTelephone;
	var isArticleFavored;
	var screenWidth;
	var articleFavoredSuccess;
	var fontSize;
	var ad_data;
    var imageHostUrl; //图片
    var newsHostUrl;	//资讯
    var forumHostUrl;	//论坛
    var routeHostUrl;	//路线
    var productHostUrl; //产品
    var shopHostUrl;	//车店

	var headerContainer = document.querySelector('#header-container');
	var recommendItemContainer = document.querySelector('#recommend-item-container');
	// var columnContainer = document.querySelector('#column-container');
	var container = document.querySelector('#view-newsDetail .content .bd');
	var recommendContainer = document.querySelector('#recommend-container');
	var authorIntroductionr = document.querySelector('#author-introduction');
	// var contentFooterContainer = document.querySelector('#content-footer');
	var tagsListContainer = document.querySelector('#tags-list');
    var hotComment = document.querySelector('#hot-comment');
	var hotCommentList = document.querySelector('#hot-comment-list');
	var noComment = document.querySelector('#no-comment');
	// var newColumnContainer = document.querySelector('#column-new');

	// 入口
	var initialize = function() {
//		var vConsole = new VConsole(); // 控制台打印开关 上线关闭

    // 加速响应点击事件 类似 onTouch事件
        FastClick.attach(document.body);

		// 打开调试模式 (默认 false)
        var enableDebug = false;
//          var enableDebug = true;

		enableDebug ? initDebug() : initBridge();

	};

	// 本地调试 (WebHttpRequest )
	var initDebug = function() {
		// DetailContent.init({'aid': '31527', 'classid': '2'});
		DetailContent.init({'aid': '35965', 'classid': '15', 'access_token': '83b106a7f0d1dd5fb1c0c3b8b399995526941'});
		$(document).on('ajaxSucces', function(response, detailsObj) {
			if (detailsObj.classid && detailsObj.id) render(detailsObj);
			if (detailsObj.guide) {}
			setHeaderContainer(detailsObj);// 头部
			setRecommendItemContainer(detailsObj);//优选
			tagsList(detailsObj.tagList);// 标签
//            authorIntroductionList(detailsObj.authorList);// 作者介绍
            authorIntroductionList(detailsObj.author);// 作者介绍  注：4.6.2版本启用新字段author
			advertisingInsertToArticleContent(detailsObj.ad_data);// 内嵌广告
			recommentArticleList(detailsObj.recommendList); // 更多推荐
//            onClickLiksDelegate();
			configureUI(detailsObj);
		})

		screenWidth = document.body.clientWidth;
		fromurl = 'http://biketo.com/mobile/#index'
		isArticleFavored = 0;
		diggtop = 2;
		fontSize = 22;
        imageHostUrl = 'https://www.biketo.com';
		articleFavoredSuccess = false;
        
		return false;
	}

	// 调用OC返回的数据
	var initBridge = function() {

        // 接收来自android的回调
		window.newsDetailInit = function(data) {

				fontSize = data.fontSize;                     // 原生中设置的字体大小
				screenWidth = data.screenWidth;               // 设备宽度
				screenHeight = data.screenHeight;             // 设备高度
				isCelluarTelephone = data.isCelluarTelephone; // 是否开启省流量模式 (在应用中我的设置中)
				isArticleFavored = data.isArticleFavored;     // 是否已经收藏 （通过匹配 NSUserDefault中存储数据判断）
				// 获取域名
//                imageHostUrl = data.imageHostUrl; //图片
                imageHostUrl = data.imageSdnHost;

//                newsHostUrl = data.newsHostUrl;	//资讯
                newsHostUrl = "www.biketo.com";

//    			forumHostUrl = data.forumHostUrl;	//论坛
                forumHostUrl = "bbs.biketo.com"

//    			routeHostUrl = data.routeHostUrl;	//路线
    			routeHostUrl = 'lx.biketo.com'

//    			productHostUrl = data.productHostUrl; //产品
    			productHostUrl = 'p.biketo.com'

//    			shopHostUrl = data.shopHostUrl;	//车店
    			shopHostUrl = 's.biketo.com'

				// details object
                var detailsObj = data.details;

				fromurl = detailsObj.fromurl;
				aid     = detailsObj.id;
				classid = detailsObj.classid;
				diggtop = detailsObj.diggtop;

				// 渲染html
				render(detailsObj);
                // 顶部视频
				setTopVideo(detailsObj);
				// 头部
				setHeaderContainer(detailsObj);

				// 优选
				setRecommendItemContainer(detailsObj);

				// 栏目
				setColumnContainer(detailsObj.column);

				//没有栏目 设置吸顶作者 by Dong
				if(!detailsObj.column)setTopAuthorContainer(detailsObj.author)

                //标签
                tagsList(detailsObj.tagList);

				// 内嵌广告
				advertisingInsertToArticleContent(detailsObj.ad_data);

                // 作者介绍
//                authorIntroductionList(detailsObj.authorList);
				authorIntroductionList(detailsObj.author);//注：4.6.2版本启用新字段author

				// 热门评论
				setHotComment(detailsObj);

				// 来自栏目
				setNewColumn(detailsObj);

				// 设置字体大小
				setContainerFontSize(fontSize);

				// 更多推荐
				recommentArticleList(detailsObj.recommendList);

                //点击事件处理
                onClickLiksDelegate();

                //配置UI显示
				configureUI(detailsObj);

				//added by Dong
                androidSetup(detailsObj);
		}

        //刷新文章喜欢的状态
		window.refreshArticleFavorStatus = function (data) {
			articleFavoredSuccess = true;
			//TODO:callback??
		}

		window.refreshAuthorFollowStatus = function (data){
                var follow = data.follow;
                var authorFollowImg = authorIntroductionr.querySelector('.right .follow-img-container .follow');
                var topFollowImg = document.querySelector("img#top-btn-follow-author");//头部 如有
                if (follow == 1) {
                    authorFollowImg.src = 'img/btn_followed.png';
                    authorFollowImg.onclick = function(e){};
                    topFollowImg.src = 'img/btn_followed.png';
                }
                else {
                    authorFollowImg.src = 'img/btn_follow_highlight.png';
                    authorFollowImg.onclick = function (e) {
                        e.stopPropagation();
                        //android, 传入作者id
                        window.ANDROID.didClickAuthorFollowBtnFromWebView();
                    }
                    topFollowImg.src = 'img/btn_follow_normal.png';
                    topFollowImg.onclick = function(e){
                        e.stopPropagation();
                        //android, 传入作者id
                        window.ANDROID.didClickAuthorFollowBtnFromWebView();
                    }
                }
		}

//		Bridge.connect(function(bridge){
//
////			bridge.init(function(message, responseCallback) {
////				if (message == 'refreshArticleFavorStatus') {
//            bridge.registerHandler('refreshArticleFavorStatus', function(data, responseCallback) {
//					articleFavoredSuccess = true;
//					responseCallback()
////				}
//			});
//
//			bridge.registerHandler('sendNewsDetailJsonToJS', function(data, responseCallback) {
//
//				fontSize = data.fontSize;                     // 原生中设置的字体大小
//				screenWidth = data.screenWidth;               // 设备宽度
//				screenHeight = data.screenHeight;             // 设备高度
//				isCelluarTelephone = data.isCelluarTelephone; // 是否开启省流量模式 (在应用中我的设置中)
//				isArticleFavored = data.isArticleFavored;     // 是否已经收藏 （通过匹配 NSUserDefault中存储数据判断）
//				// 获取域名
//                imageHostUrl = data.imageHostUrl; //图片
//                newsHostUrl = data.newsHostUrl;	//资讯
//    			forumHostUrl = data.forumHostUrl;	//论坛
//    			routeHostUrl = data.routeHostUrl;	//路线
//    			productHostUrl = data.productHostUrl; //产品
//    			shopHostUrl = data.shopHostUrl;	//车店
//
//				// details object
//                var detailsObj = data.html.details;
//
//				fromurl = detailsObj.fromurl;
//				aid     = detailsObj.id;
//				classid = detailsObj.classid;
//				diggtop = detailsObj.diggtop;
//
//				// 渲染html
//				render(detailsObj);
//
//				// 头部
//				setHeaderContainer(detailsObj);
//
//				// 优选
//				setRecommendItemContainer(detailsObj);
//
//				// 栏目
//				setColumnContainer(detailsObj.column);
//
//                //标签
//                tagsList(detailsObj.tagList);
//
//				// 内嵌广告
//				advertisingInsertToArticleContent(detailsObj.ad_data);
//
//                // 作者介绍
////                authorIntroductionList(detailsObj.authorList);
//				authorIntroductionList(detailsObj.author);//注：4.6.2版本启用新字段author
//
//				// 热门评论
//				setHotComment(detailsObj);
//
//				// 来自栏目
//				setNewColumn(detailsObj);
//
//				// 设置字体大小
//				setContainerFontSize(fontSize);
//
//				// 更多推荐
//				recommentArticleList(detailsObj.recommendList);
//
//                //点击事件处理
//                onClickLiksDelegate();
//
//                //配置UI显示
//				configureUI(detailsObj);
//
//				// responseCallback();
//			});
//
//            bridge.registerHandler('refreshAuthorFollowStatus', function(data, responseCallback) {
//                var follow = data.follow;
//
//                authorIntroductionr.querySelector('.right .follow-img-container .follow').src = 'img/btn_author_followed_small.png';
//            });
//
//			// 动态修改字体大小
//			bridge.registerHandler('sendNewsDetailFontSize', function(data, responseCallback) {
//				setContainerFontSize(data);
//				responseCallback();
//			});
//        });
	}

	var configureUI = function(detailsObj) {
		// 请求拿到数据结果后才显示，（否则在请求过程中会显示空的栏目）
		if (detailsObj.guide_list && detailsObj.bigImgMode == 1 && detailsObj.guide_list.length > 0) {
			document.body.removeChild(document.getElementById("header-container"));
			$(recommendItemContainer, container).css('visibility', 'visible');
		}
		else {
			document.body.removeChild(document.getElementById("recommend-item-container"));
			$(headerContainer, container).css('visibility', 'visible');
		}

		if (detailsObj.column) {
		    $('#column-container, #column-new').css('display', 'block');
		}
		else if (detailsObj.author && detailsObj.author.id && detailsObj.author.type==2){//吸顶部分，没有栏目则显示作者数据 added by Dong
		    $('#column-container').css('display', 'block');
		    //头像为圆形
		    $('#column-container .column-avatar').addClass('top-author-avatar')
		    //栏目和作者的关注按钮分开，其它位置公用
		    $('#column-container #top-btn-follow-author').css('display', 'inline-block');
		    $('#column-container #top-btn-follow-column').css('display', 'none');
		}

		if (detailsObj.recommendList) $(recommendContainer).css('display', 'block');
		if (detailsObj.tagList) {$(tagsListContainer).css('visibility', 'visible')};
		if (!detailsObj.show_comment) {
			$(noComment).css('display', 'block');
		} else {
		    $(hotComment).css('display', 'block');
			$(hotCommentList).show();
			$(noComment).remove();
		}

	}

	// 渲染HTML
	var render = function(details) {

		var newstext = details.newstext.replace(/(\[!--empirenews.page--\])/g, '')
									   .replace(/(<img[^>]*?)src/ig, function(all,$1){
											return $1 +'src="img/image-loading.png" data-src';
										})
									   .replace(/<span[^>]*>/g, '')
									   .replace(/<em[^>]*>/g, '')
									   .replace(/<(?!img|table|iframe|a|strong|p|\/p|div|\/div|).*?>/g, '')
        if (details.fromurl != "") {
            newstext += '<a href="'+ details.fromurl +'" style="text-align:right;display:block;color:#1884FF;text-decoration:none;">[ 本文来源 ]</a>';
        }
        
		var content = document.querySelector('#view-newsDetail .content');
		container.innerHTML.scrollTop = 0;
		container.style.fontSize = '16px';
		$(container).html(newstext);
		setContainerStyleAndOperation( content , container.clientWidth)
	}

	// onclick 事件委托
	var onClickLiksDelegate = function() {

		var delegateHandle = function(event) {
			event.preventDefault();

			var me = $(this);
			var src = me[0].href;

			// 点击图片
			if (me[0].tagName == 'IMG' && me.parents('.avatar').length == 0) {

				var imgAll = $('section#view-newsDetail img');
				var json = {};
				var imagesList = [];
				var currentImage;

				imgAll.each(function(){
					imagesList.push(this.src);
				})

				//所有评论图片 added by Dong
				var commentImgAll = $('section#hot-comment .comment-pic img');
				commentImgAll.each(function(){
				    imagesList.push(this.src)
				})
				//end

				json.imagesList = imagesList;
				json.currentImage = me[0].src;

                //ios commented out by Dong
//				try {
//					Bridge.connect(function(bridge){
//						bridge.callHandler('didClickImageViewFromWebView', {'imagesList': json.imagesList, 'currentImage': json.currentImage})
//					});
//				} catch(error){
//					console.log('imagesList: ' +json.imagesList, 'currentImage: '+ json.currentImage)
//				}
                //android
                try{
                    event.stopPropagation();//防止传播到父类
                    window.ANDROID.didClickImageViewFromWebView( JSON.stringify({'imagesList': json.imagesList, 'currentImage': json.currentImage}))
                }catch(error){
					console.log('imagesList: ' +json.imagesList, 'currentImage: '+ json.currentImage)
                }
			}

			// 点击超链接
			if (me[0].tagName == 'A' && me.attr('href') != undefined) {

				if (src == 'javascript:;') return;

				// 推荐广告
				if (me.parent().hasClass('hasAdvertising')) {

                    //ios commented out by Dong
//					Bridge.connect(function(bridge){
//						bridge.callHandler('didClickArticleAdvertisingFromWebView', {'ad_data': ad_data});
//					});

					//android
					window.ANDROID.didClickArticleAdvertisingFromWebView(JSON.stringify({'ad_data': ad_data}));

					console.log('didClickArticleAdvertisingFromWebView: ', ad_data);

					return;
				};

				var liksResultJson = getLiksIdAndType(src);

				if (liksResultJson) {
				    //ios commented out by Dong
//                    Bridge.connect(function(bridge){
//                        bridge.callHandler('delegateUIWebViewOnClikEvent', {'result': liksResultJson})
//                    });

                    //android
                    window.ANDROID.delegateUIWebViewOnClikEvent(JSON.stringify({'result': liksResultJson}));
				}
			}

			// 点击标签 tagList
			if (me.attr('data-tagid')) {
				var tagid = me.attr('data-tagid');
				var tagname = me[0].innerHTML;

                //ios commented out by Dong
//				Bridge.connect(function(bridge){
//					bridge.callHandler('didClickArticleTagOnTagIdFromWebView', { 'tagid': tagid, 'tagname': tagname })
//				});

				//android
				window.ANDROID.didClickArticleTagOnTagIdFromWebView(tagid, tagname);
			}

		}

//        $('section').undelegate().delegate('a, img', 'click', delegateHandle);
        $('img')
            .not('#column-new img')//去掉关注按钮 by Dong
            .not('div.follow-img-container img.follow')//去掉关注按钮 by Dong
            .not('.column-avatar')
            .click(delegateHandle);
        $('a').click(delegateHandle);
	}

//	// 获取论坛tid 和资讯aid
//	var getLiksIdAndType = function(src) {
//
//		var domains = (src.indexOf('https://') != -1) ? src.replace('https://','') : src.replace('http://','');
//		var splitDomains = domains.split('.');
//		var result = {};
//
//		// 专题
//		if (splitDomains[0] == 'www' && splitDomains[2].split('/')[1] == 's') {
//			result = {'id':splitDomains[2].split('/')[2], 'src': src, 'type':'zt'};
//		}
//
//		// 资讯
//		else if (splitDomains[0] == 'www' && splitDomains[1] == 'biketo') {
//
//			var strSplit = src.split('/');
//			var lastStr = strSplit[strSplit.length -1];
//			var idStr = lastStr.split('.')[0];
//
//			// 如果是分页
//			if (idStr.indexOf('_') != -1) idStr = idStr.split('_')[0];
//
//			if (!isNaN(idStr)) {
//				result = (idStr && idStr.length <= 6 ) ? {'id':idStr, 'src': src, 'type':'news'} : {'id':idStr, 'src': src, 'type':'default'};
//			} else {
//				result = {'id':'', 'src': src, 'type':'default'};
//			}
//
//		}
//
//		// 论坛
//		else if (splitDomains[0] == 'bbs' && splitDomains[1] == 'biketo') {
//			var strSplit = src.split('-');
//			var lastStr = strSplit[strSplit.length -3]
//
//			result = (lastStr && lastStr.length <= 8 ) ? {'id':lastStr, 'src': src, 'type':'bbs'} : {'id':lastStr, 'src': src, 'type':'default'};
//		}
//
//		// 外链
//		else {
//			result = {'id':'', 'src': src, 'type':'default'};
//		}
//
//		console.log(result);
//
//		return result;
//	}
        // 获取论坛tid 和资讯aid
    var getLiksIdAndType = function(src) {
        
        var domains = src.replace('http://','');
        domains=domains.replace('https://','');
        domains=domains.toLocaleLowerCase();

        var newsHost = newsHostUrl.replace('http://','');
        newsHost = newsHost.replace('https://','');

        var forumHost = forumHostUrl.replace('http://','');
        forumHost = forumHost.replace('https://','');

        var routeHost = routeHostUrl.replace('http://','');
        routeHost = routeHost.replace('https://','');

        var shopHost = shopHostUrl.replace('http://','');
        shopHost = shopHost.replace('https://','');

        var productHost = productHostUrl.replace('http://','');
        productHost = productHost.replace('https://','');

        var splitBlock = domains.split('/');
        var result = {};

        //Out, News, Forum, Web, Special, Photo, Store, Product, Line, Live
        result = {'type':'Out', 'aid':'', 'url': src};
        if(splitBlock.length > 1 && splitBlock[0].indexOf('biketo.com') != -1){
            //专题
            if(splitBlock.length > 2 && splitBlock[0].indexOf(newsHost) != -1 && splitBlock[1] == 's'){
                result = {'type':'Special', 'aid':splitBlock[2], 'url': src};
                //资讯文章
            }else if(splitBlock.length > 1 && splitBlock[0].indexOf(newsHost) != -1){
                    var lastStr=splitBlock[splitBlock.length -1];
                    var idStr = lastStr.split('.')[0];
                    // 如果是分页
                    if (idStr.indexOf('_') != -1) idStr = idStr.split('_')[0];
                    if (!isNaN(idStr) && idStr && idStr.length <= 6) {//是否为数字值
                        result = {'type':'News', 'aid':idStr, 'url': src};
                    }
        
                //论坛帖子
            }else if (splitBlock.length > 1 && splitBlock[0].indexOf(forumHost) != -1) {
                var lastStr=splitBlock[splitBlock.length -1];
                var strSplit = lastStr.split('-');
                if(strSplit.length>1 && strSplit[0].indexOf('thread') != -1){
                    var idStr=strSplit[1];
                    if (!isNaN(idStr) && idStr && idStr.length <= 8) {//是否为数字值
                        result = {'type':'Forum', 'aid':idStr, 'url': src};
                    }
                }
            //产品库
            }else if(splitBlock.length > 1 && splitBlock[0].indexOf(productHost) != -1){
                var lastStr=splitBlock[splitBlock.length -1];
                var idStr = lastStr.split('.')[0];
                if (!isNaN(idStr) && idStr) {//是否为数字值
                    result = {'type':'Product', 'aid':idStr, 'url': src};
                }
            //车店库
            }else if(splitBlock.length > 1 && splitBlock[0].indexOf(shopHost) != -1){
                var lastStr=splitBlock[splitBlock.length -1];
                    var idStr = lastStr.split('.')[0];
                    if (!isNaN(idStr) && idStr) {//是否为数字值
                        result = {'type':'Store', 'aid':idStr, 'url': src};
                    }
            //路线库
            }else if(splitBlock.length > 1 && splitBlock[0].indexOf(routeHost) != -1){
                var lastStr=splitBlock[splitBlock.length -1];
                var idStr = lastStr.split('.')[0];
                if (!isNaN(idStr) && idStr) {//是否为数字值
                    result = {'type':'Line', 'aid':idStr, 'url': src};
                }
            }
        }else if(splitBlock.length > 1 && splitBlock[0].indexOf('racegood.com') != -1){
            result = {'type':'Web', 'aid':'', 'url': src};
        }
        
        return result;
    }
        
	// 设置相关样式
	var setContainerStyleAndOperation = function(newstext, containerWidth) {
		// 遍历dom节点
		var allDom = newstext.getElementsByTagName('p');
		var collectTemp = [];
		var imagesIndex = 0;
		var imageCount = 0;

		for (var i = 0; i < allDom.length; i++) collectTemp[collectTemp.length] = allDom[i];

        // Imges Tage
        var lineImagesForEach = function(i) {
            var $this = $(this);
            var $imageParent = $this.parents('p');
            imagesIndex ++;
            // 获取图片地址
            var imgSrc = $this.attr('data-src');
            var isDailysImgIcon = $this.attr('data-width') == 99 ? true : false; // 判断是否是每一图的下载按钮图标
            var imageSize = isDailysImgIcon ? "" : setImageSize(imgSrc);
            var sdnRootUrl = imgSrc;
            if (imgSrc.indexOf('http') == -1) { 
            	sdnRootUrl = imageHostUrl + imgSrc + imageSize;
            }
            var imgWidth = $this.attr('width');
            var imgHeight = $this.attr('height');
            var imgDataWidth =  $this.attr('data-width');
			var imgDataHeight =  $this.attr('data-height');
			var customWidth = containerWidth;


			// 默认高度 3:2
			var w = customWidth ;
            var h = customWidth * 2 / 3;
        	if( imgWidth && imgHeight ){
				w = imgWidth ;
				h = imgHeight ;
				if( imgWidth > customWidth ){
					w = customWidth ;
					h = customWidth * imgHeight / imgWidth;
				}
			}else if( imgDataWidth && imgDataHeight ){
				w = imgDataWidth ;
				h = imgDataHeight ;
				if( imgDataWidth > customWidth ){
					w = customWidth ;
					h = customWidth * imgDataHeight / imgDataWidth;
				}
			}

            var imagesLength = collectTemp.length;
        
            $this.attr('data-index', imagesIndex);
        
            var img = new Image();
            img.src = sdnRootUrl;
            //$this.style.borderRadius = '10px';
    
            // 外连图片
            if (imgSrc.indexOf('http://') != -1|| imgSrc.indexOf('https') != -1) {
                $this.attr('src', imgSrc);
            }
            else {
                $this.attr('src', 'img/image-loading.png');
                // 加载完成执行
                img.onload = function(){
                    $this.addClass('animated fadeIn');
                    $this.attr('src', this.src); // www.biketo.com
                }
            }

            // 图片宽度
			$this.width(w);
			$this.height(h);
            $this.css({'border-raduis':'10px'});

            // 图片居中 文字缩进 下边距
            $imageParent.css({ 'text-align': 'center', 'margin-bottom': '0', 'text-indent': '0'});
    
  
            // 判断每日一图下载图标时隐藏, 判断图片高宽度 ( 如果img的上上级元素是P元素，并且包含2个a元素 或 其中一个是a元素 )
            var that = $this.parents('a');
            if (that.length !=0 ) {
                if (that.length == 2 || that[0].tagName == 'A' || that[1].tagName == 'A') {
                    $imageParent.remove();
                }
            }

            //5.1新加入，图片描述
            var imgIntroClass = $this.attr('class');
            if (imgIntroClass && imgIntroClass.indexOf('img-intro') !== -1) {
                console.log($this.attr('data-desc'));
                if ($this.attr('data-desc')) {
                    $this.parent().after('<p style="text-align: center" class="img-intro-des">\u25b2'+  $this.attr('data-desc') +'</p>');
                }
            }

        }
        
		var firstForEache = function(i) {

			var $this = $(this);
			var $imagesTag = $this.find('img');
			var $iframeTag = $this.find('iframe');
			var $embedTag = $this.find('embed');
			var $imageParent = $imagesTag.parents('p');
			$this.find('strong').css('font-size', fontSize +1);
        
            //图片
            if( $imagesTag.length > 0 ){
                $imagesTag.each(lineImagesForEach);
            }

			// Iframe Tag
			if ($iframeTag[0]) {
				// $iframeTag.attr('src', $iframeTag.attr('data-src'));
				// $iframeTag.parents('p').css({'text-align': 'center', 'text-indent': '0'})
				// $iframeTag.css({'height': containerWidth / (3/2) +'px'})

				$iframeTag.attr('src', $iframeTag.attr('data-src'));
				$iframeTag.attr('allowfullscreen','true');
				$iframeTag.parents('p').css({'text-align': 'center', 'text-indent': '0'});
                var iframeHeight = $iframeTag ? $iframeTag.attr('height') : '0';
                var scaleHeight = containerWidth * (2/3);
                iframeHeight = iframeHeight.replace('px','');
                if(iframeHeight > scaleHeight){
				    $iframeTag.css({'height': scaleHeight +'px'});
                }
			};

			// Embed tag 非HTML的视屏，直接删除
			if ($embedTag) $embedTag.remove();

			// 倒数第二个p元素
			// if (i == collectTemp.length -2) {
      //     if (fromurl) $(collectTemp[i]).append(' <a class="source-link-btn" href="'+fromurl+'">[查看本文来源]</a>');
			// }

			// 最后一个p元素
			if (i == collectTemp.length -1) {
				if (collectTemp[i].innerHTML.indexOf('责任编辑') <= 1) collectTemp[i].style.textAlign = "left";
			};
		}

		var lineImagesSecondEach = function(i) {
			var $this = $(this);
			var $imagesTag = $this.find('img');
        
			var imgSrc =  $this.attr('data-src');
			var imgWidth =  $this.attr('width');
			var imgHeight =  $this.attr('height');
			var imgDataWidth =  $this.attr('data-width');
			var imgDataHeight =  $this.attr('data-height');

			var customWidth = containerWidth;
			var scale = imgWidth/customWidth;
			var heightScale = Math.floor(imgHeight/scale);

			if( imgWidth && imgHeight ){
				return;
			}
			if (imgDataWidth && imgDataHeight){
				return;
			}

			// 如果是外链则跳过
            if ( imgSrc.indexOf('http://') != -1|| imgSrc.indexOf('https') != -1) {
                $this.css({ 'width': '100%', 'height': 'auto' });
                return;
            }

			// 否则将通过服务器图片API获取高度
			var requestGetImageInfoCallback = function(response) {
				// 计算图片比例
				var height = response.height;
				var width = response.width;
				var customWidth = containerWidth;

				var w = customWidth ;
				var h = customWidth * 2 / 3;
				if( width && height ){
					w = width ;
					h = height ;
					if( width > customWidth ){
						w = customWidth ;
						h = customWidth * height / width;
					}
				}
			
				if (!$this) return;

				var imagesIndex = $this.attr('data-index');

				// 设置图片宽高
		        $this.width(w);
				$this.height(h);
			}

			// 获取占位符高度, 并返回最终的高度
			$.ajax({type : 'get',
				url : 'https://ofac4w3f7.qnssl.com' + imgSrc +'?imageInfo&time='+new Date().getTime(),
				data : '',
				async : true,
				success : requestGetImageInfoCallback
			});
		}

		var secondForEache = function(i) {
			var $this = $(this);
			var $imagesTag = $this.find('img');

			if($imagesTag.length>0){
				$imagesTag.each(lineImagesSecondEach);
			}
		}

		$(collectTemp).each(firstForEache);
		$(collectTemp).each(secondForEache);

		collectTemp = null;
	}

	// 设置图片大小，从OC中获取
	var setImageSize = function(imageSrc) {
	    if(!imageSrc)return;

		//是否开去省流量模式
		var imageW = '';

		if (isCelluarTelephone == 1) {
			imageW = '?x-oss-process=image/resize,w_' +screenWidth;
		} else {
			imageW = '?x-oss-process=image/resize,w_640';
		}
        
        if (imageSrc.indexOf('.gif') == -1) {
            imageW = imageW + '/format,webp';
        }

		return imageW;
	}

	// 字体大小
	var setContainerFontSize = function(fontSize) {
		$(container).css('font-size', fontSize +'px');
		var headerFontSize = new Number(fontSize);
		$(headerContainer).find('.title').css('font-size', (headerFontSize += 8) +'px');
	}

    var setTopVideo = function(detailsObj) {
		var videoUrl = detailsObj.video_url;
		var reg = /\.(mp4|swf|avi|flv|mpg|rm|mov|wav|asf|3gp|mkv|rmvb)$/i;

		if (videoUrl) {
			$('.video-or-iframe').css('visibility','visible');
		} else {
			$('.video-or-iframe').remove();
			return;
		}
		var result = reg.exec(videoUrl);
		var titlePic = detailsObj.video_url_img;
		var videoHtml = '';
		if (result) {
			videoHtml = '<video src="'+ videoUrl +'" poster="'+ imageHostUrl + titlePic +'" controls="controls" preload="preload" playsinline webkit-playsinline></video>'
		} else {
			videoHtml = '<iframe src="'+ videoUrl +'"></iframe>'
		}
		$('.video-or-iframe').html(videoHtml);
	}
	// 头部
	var setHeaderContainer = function(data) {
		$(headerContainer).find('.title').html(data.title);
		$(headerContainer).find('#header-container-author').html(data.writer);
		$(headerContainer).find('#header-container-time').html(data.newstime);
		$(headerContainer).find('#header-container-click').html(data.onclick);
	}

	//优选
	var setRecommendItemContainer = function(data) {
		if (!data.guide_list) {return;}
		var guide_item = data.guide_list[0];

		$(recommendItemContainer).find('.title').html(data.title);
		$(recommendItemContainer).find('#recommend-item-container-author').html(data.writer);
		$(recommendItemContainer).find('#recommend-item-container-click').html(data.onclick);
		$(recommendItemContainer).find('#recommend-item-container-time').html(data.newstime);
		$(recommendItemContainer).find('#recommend-item-container-price-label').html('￥' + guide_item.price);
		$(recommendItemContainer).find('#recommend-item-container-link-source').html('/ ' + guide_item.link_type_text);
		
         $('.title-img').css('background','url(' + imageHostUrl + guide_item.img_url + setImageSize(guide_item.img_url) + ') no-repeat center');
         $('.title-img').css('background-size', 'cover');

		recommendItemContainer.setAttribute('gid', guide_item.gid);

		//优选点击跳转
		// recommendItemContainer.onclick = function() {
		// 	var gid = recommendItemContainer.getAttribute('gid');
		// 	if (!gid) {return;}
		// 	Bridge.connect(function(bridge){
		// 		bridge.callHandler('didClickGuidItemFromWebView', { 'gid': gid })
		// 	});
		// }
	}

	// 没有栏目数据的话，吸顶显示作者数据
    var setTopAuthorContainer = function(author){
        if(!author || !author.id || author.type==1) return;//编辑类作者也不显示
		var $column = $('#column-container, #column-new');
		$column.find('#top-btn-follow-column').css("display","none");//隐藏掉栏目关注按钮
		$column.find('#top-btn-follow-author').css("display", "inline-block");
		$column.find('.column-avatar').attr('src', author.userpic);
		$column.find('.column-name').html(author.name)
		$column.find('.column-tag').html(author.position)
		$column.find('.column-intro').html(author.description);
		if (author.follow == 1) {
			$('#column-container').find('#top-btn-follow-author').attr('src', 'img/btn_followed.png');
		} else {
			$('#column-container').find('#top-btn-follow-author').attr('src', 'img/btn_follow_normal.png');
		}

		//栏目点击，包括吸顶的栏目和底部的栏目
		//added by Dong
		$column.find('#column-content, .column-content').click(function(){
		    window.ANDROID.didClickArticleAuthorIntroFromWebView(
		        JSON.stringify({ 'id': author.id ,'authorname': author.name, 'userpic': author.userpic, 'description': author.description, 'position': author.position, 'type': author.type })
		    )
		});
    }

	// 栏目 + 来自栏目
	var setColumnContainer = function(data) {
		if (!data) {
		    return;
		}
		var $column = $('#column-container, #column-new');
		$column.find('.column-avatar').attr('src', imageHostUrl + data.avatar); //test: www.dev.biketo.com | online: c5.biketo.com
		$column.find('.column-name').html(data.name)
		$column.find('.column-tag').html(data.tag)
		$column.find('.column-intro').html(data.intro);
		if (data.follow == 1) {
//			$('#column-container').find('.column-right').attr('src', 'img/btn_followed.png');
            $('#column-container').find('#top-btn-follow-column').attr('src', 'img/btn_followed.png');
			$('#column-new').find('.column-right').attr('src', 'img/btn_followed.png');
		} else {
//			$('#column-container').find('.column-right').attr('src', 'img/btn_follow_normal.png');
            $('#column-container').find('#top-btn-follow-column').attr('src', 'img/btn_follow_normal.png');
			$('#column-new').find('.column-right').attr('src', 'img/btn_follow_column_highlight.png');
		}

		//栏目点击，包括吸顶的栏目和底部的栏目
		//added by Dong
		$column.find('#column-content, .column-content').click(function(){
		    window.ANDROID.didClickColumnFromWebView(data.column_id)
		});
	}

    // 文章标签
	var tagsList = function(tagList) { 
	    if(!tagList||!tagList.length){
	        $(tagsListContainer).remove();
	        return;
	    }
		var listDom = tagsListContainer.querySelector('ul');
		$(tagList).each(function(){
			var that = $(this)[0];
			$(listDom).append('<li><a data-tagid="'+that.tagid+'">'+that.tagname+'</a></li>');
		})
	}

    // 文章作者列表
	var authorIntroductionList = function(respones) {

        if (!respones || !respones.id) {
            return false;
        }

//        var data = respones[0];
        var data = respones;
        var authorname = data.name;
		var description = data.description;
		var position = data.position;
        var columnid = data.id; //data.columnid;
		var userpic = data.userpic;
        var grade = data.grade;
        var honor = data.honor;
        var type = data.type;
        var follow = data.follow;

		$('#author-introduction').css('display', 'block');
		$('#author-introduction .right').css('width', '96%'); // fixbug
        authorIntroductionr.setAttribute('data-columnid', columnid);
		authorIntroductionr.querySelector('.right .name').innerHTML = authorname;
		authorIntroductionr.querySelector('.right .info').innerHTML = position;
        authorIntroductionr.querySelector('.right p').innerHTML = '简介：'+ description;
        
        var authorFollow = authorIntroductionr.querySelector('.right .follow-img-container');
        if (type == 2) {

            authorIntroductionr.querySelector('.left .avatar img').src = userpic;

            if (grade != 0) {
                var gradeDom = new Image();
                gradeDom.setAttribute('class', 'grade');
                gradeDom.src = 'img/icon_author_grade_' + grade + '.png';
                //append 5.0不兼容
//                authorIntroductionr.querySelector('.right .tag-img-container').append(gradeDom);
                authorIntroductionr.querySelector('.right .tag-img-container').appendChild(gradeDom);
            }

            if (honor != 0) {
                var honorDom = new Image();
                honorDom.setAttribute('class', 'honor');
                honorDom.src = 'img/icon_author_tag_' + honor + '.png';
//                authorIntroductionr.querySelector('.right .tag-img-container').append(honorDom);
                authorIntroductionr.querySelector('.right .tag-img-container').appendChild(honorDom);
            }

            var followImg = new Image();
            followImg.setAttribute('class', 'follow');
            if (follow == 1) {
                followImg.src = 'img/btn_followed.png';
            }
            else {
                followImg.src = 'img/btn_follow_highlight.png';
                authorFollow.onclick = function (e) {
                    e.stopPropagation();

                    //点击关注作者
                    //ios commented out by Dong
//                    Bridge.connect(function(bridge){
//                            bridge.callHandler('didClickAuthorFollowBtnFromWebView', {'follow': follow})
//                    });

                    //android
                    window.ANDROID.didClickAuthorFollowBtnFromWebView();
                }
            }
//            authorFollow.append(followImg);
            authorFollow.appendChild(followImg);
        }
        else {
            authorIntroductionr.querySelector('.left .avatar img').src = userpic;
        }
        //作者点击
		authorIntroductionr.onclick = function() {
			var columnid = authorIntroductionr.getAttribute('data-columnid');
			if (!columnid) return;

			//ios
//			Bridge.connect(function(bridge){
//				bridge.callHandler('didClickArticleAuthorIntroFromWebView', { 'columnid': columnid ,'authorname': authorname, 'userpic': userpic, 'description': description, 'position': position, 'type': type })
//			});

			window.ANDROID.didClickArticleAuthorIntroFromWebView(JSON.stringify({ 'id': columnid ,'authorname': authorname, 'userpic': userpic, 'description': description, 'position': position, 'type': type }))
		}
	}

	//android修改emoji为本地路径
	var replaceEmoji = function(str) {
        var str2 = str.replace(/\[~em_(\d+)\~]/g, function(item, index){
            return "<img class='emoji' src='file:///android_asset/face/" + index + ".png' border='0'>"
        });
        return str2;
    }

	var setHotComment = function(data) {
		console.log(data);
		if (!data.hotcommentList || data.hotcommentList.length == 0) {
			$(hotCommentList).remove();

			//暂无评论
			//added by Dong
			$('div#empty-comment').css("display","block");

			return;
		}
		var commentArr = data.hotcommentList;
		var htmlStr = artTemplate('ejs-comment-item', {item: commentArr});
		htmlStr = replaceEmoji(htmlStr);//android
		$(hotCommentList).prepend($(htmlStr));
		$('#plnum').html(data.plnum);
	}
	var setNewColumn = function(data) {
	    //加10是为了给最后一个元素加上右padding，防止贴边
		if (data.column && data.column.news.length) {
			var htmlStr = artTemplate('ejs-column-new', {datas: data.column.news})
		    $('#warp').css('width', data.column.news.length * 223 + 10 +'px').append($(htmlStr));
		}

		//added by Dong
		//android
		$('#warp').find('.column-new-item').click(function(e){
		    window.ANDROID.didClickColumnArticleFromWebView($(e.currentTarget).data("news-id"))
		})
	}

	// 更多推荐
	var recommentArticleList = function(model) {
		if (!model) return false;
		var list = $(recommendContainer).find('.recommend-list');

		for (var i = 0; i < model.length; i++) {
			var teamplateItemHtml = '<li>'+
															'<a href='+model[i].uri+'>'+
															'<div class="titileImage"><img src="'+imageHostUrl+'/d/imagecache/in/240x180/'+model[i].titlepic+'"></div>'+
															'<div class="titleText">'+model[i].title+'</div>'+
															'<span class="columnNameText">'+model[i].column_name+'</span>'+
															'<span class="hitsText">'+model[i].onclick+' 点击</span>'+
															'<span class="timeText">'+model[i].time_str+'</span>'+
															'</a>'+
															'</li>';
			$(list).append(teamplateItemHtml);
		}
	}

  // 内嵌广告
	var advertisingInsertToArticleContent = function(data) {
        if (!data) {
            $('#advertising-container')
            .css('display', 'none');
            return;
        }
        
		$('#advertising-container')
		.html('<img src="' +data.picurl + '">')
		.click(function(){
		    //ios commented out by Dong
//			Bridge.connect(function(bridge){
//				bridge.callHandler('didClickArticleAdvertisingFromWebView', {'ad_data': data})
//			});
			//android
			window.ANDROID.didClickArticleAdvertisingFromWebView(JSON.stringify({'ad_data': data}));

			console.log('didClickArticleAdvertisingFromWebView: ', data)
		})
	}

	// Log输出
	var log = function(message, data) {
		var logWrap = document.createElement('div');
		var log = document.getElementById('log')
		var el = document.createElement('div')
		el.className = 'logLine'
		el.innerHTML = uniqueId++ + '. ' + message + ':<br/>' + JSON.stringify(data)
		if (log.children.length) { log.insertBefore(el, log.children[0]) }
		else { log.appendChild(el) }
	}

	//android
	//added by Dong
	var androidSetup = function(data){
        //点击评论列表
	    $('#hot-comment-list').click(function(){
            window.ANDROID.didClickCommentItemFromWebView(0);
	    });

	    //吸顶点击作者关注（如果显示的是作者）
	    $('#column-content img#top-btn-follow-author').click(function(e){//吸顶部分
	        e.stopPropagation();
	        window.ANDROID.didClickAuthorFollowBtnFromWebView();
	    });

	    //点击栏目关注
	    $('#column-content img#top-btn-follow-column').click(function(e){//吸顶部分
	        e.stopPropagation();
	        window.ANDROID.didClickColumnFollowBtnFromWebView(data.column.column_id);
	    });
	    $('section#column-new img.column-right').click(function(e){//底部部分
	        e.stopPropagation();
	        window.ANDROID.didClickColumnFollowBtnFromWebView(data.column.column_id);
	    })

	    //更新栏目关注状态
        window.refreshColumnFollowStatus = function (isFollow){
            if (isFollow == 1) {
//                $('#column-container').find('.column-right').attr('src', 'img/btn_author_followed_small.png');
                $('#column-container').find('.column-right#top-btn-follow-column').attr('src', 'img/btn_followed.png');
                $('#column-new').find('.column-right').attr('src', 'img/btn_followed.png');
            } else {
//                $('#column-container').find('.column-right').attr('src', 'img/btn_author_follow_hollow.png');
                $('#column-container').find('.column-right#top-btn-follow-column').attr('src', 'img/btn_follow_normal.png');
                $('#column-new').find('.column-right').attr('src', 'img/btn_follow_highlight.png');
            }
        }
	}

	return { init : initialize };
})
